"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const defined_1 = __importDefault(require("./defined"));
const mapDefined_1 = __importDefault(require("./mapDefined"));
class ExecError extends Error {
    constructor(code, signal) {
        super("Command exited with " +
            [
                mapDefined_1.default(code, (c) => `code ${c}`),
                mapDefined_1.default(signal, (s) => `signal ${s}`),
            ]
                .filter(defined_1.default)
                .join(" and "));
        this.code = code;
        this.signal = signal;
    }
}
exports.default = ExecError;
