"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = () => {
    const waiting = [];
    let locked = false;
    const tryProgress = () => {
        if (locked) {
            return;
        }
        const next = waiting.shift();
        if (!next) {
            return;
        }
        locked = true;
        next({
            unlock() {
                locked = false;
                tryProgress();
            },
        });
    };
    return {
        isLocked() {
            return locked;
        },
        lock() {
            return new Promise((resolve) => {
                waiting.push(resolve);
                tryProgress();
            });
        },
    };
};
